#include<bits/stdc++.h>
typedef long long ll;
using namespace std; 

int main()
{   
    ios_base::sync_with_stdio(0); 
    cin.tie(0);  cout.tie(0);
   
    int t,n,m;
    
    cin >> t;
    
    while(t--) {   
        cin >> n >> m;
        ll a[n], b[m];
        for(int i=0; i<n; i++)
           cin >> a[i];
        for(int i=0; i<m; i++)
           cin >> b[i];
        
        sort(a,a+n);
        ll x = a[1] - a[0]; 
        
        for(int i=2; i<n; i++)
           x = __gcd(x,(a[i]-a[i-1]));
           
        if(x==1){
            cout << 0;
            continue;
        }
        
        int p=0;
        
        for(int i=0; i<m; i++)
            if(__gcd(x,abs(b[i]-a[0]))==x) {
              p = 1;
              cout << 0;
              break;
          }
          
        if(p==0) cout << 1; 
    }
    
    return 0;
}